// Generated by dts-bundle v0.7.3

export interface ICanvasRenderer {
    drawFilledCircle: (size: number, xPos?: number, yPos?: number, color?: string) => void;
    clear: () => void;
    canvasWidth: number;
    canvasHeight: number;
}
export default class CanvasRenderer implements ICanvasRenderer {
    constructor(ctx: CanvasRenderingContext2D);
    drawFilledCircle(size: number, xPos?: number, yPos?: number, color?: string): void;
    clear(): void;
    get canvasWidth(): number;
    get canvasHeight(): number;
}

export interface IEmitter {
    isExploding: boolean;
    explode: (numOfParticles: number, particleOptions?: ParticleOptions) => void;
    draw: () => void;
}
export type EmitterOptions = {
    pause?: boolean;
};
export default class Emitter implements IEmitter {
    constructor(canvasRenderer: ICanvasRenderer, particleFactory: IParticleFactory, options?: EmitterOptions);
    get isExploding(): boolean;
    explode(numOfParticles: number, particleOptions?: {}): void;
    draw(): void;
}

export function createEmitter(ctx: CanvasRenderingContext2D, options?: EmitterOptions): IEmitter;

export interface IParticle {
    isActive: boolean;
    xPos?: number;
    yPos?: number;
    size: number;
    color: string;
    update: () => void;
}
export type ParticleOptions = {
    xPos?: number;
    yPos?: number;
    minSize?: number;
    maxSize?: number;
    minSpeed?: number;
    maxSpeed?: number;
    resistance?: number;
    gravity?: number;
    decay?: number;
    sizeToRemove?: number;
    color?: string | string[];
};
export default class Particle implements IParticle {
    xPos: number;
    yPos: number;
    color: string;
    size: number;
    constructor(options?: ParticleOptions);
    get isActive(): boolean;
    update(): void;
    _randomNumFromRange(min?: number, max?: number): number;
    _getRandomArrayItem(arr: any[]): any;
}

export interface IParticleFactory {
    create: (options?: ParticleOptions) => IParticle;
}
export default class ParticleFactory implements IParticleFactory {
    create(options?: {}): Particle;
}

